if select(2,UnitClass("player")) ~= "MONK" then return end
local LibStub = LibStub
local AceAddon = LibStub("AceAddon-3.0")
local string_match= string.match
local tonumber = tonumber
local GetCVar = GetCVar
local min = min
local max = max
local LSM = LibStub("LibSharedMedia-3.0")

local RemUplift = AceAddon:NewAddon("RemUplift", "AceEvent-3.0","AceConsole-3.0")

local cvar_width,cvar_height = string_match(GetCVar("gxResolution"), "(%d+)x(%d+)")
cvar_width = tonumber(cvar_width)
cvar_height = tonumber(cvar_height)
local cvar_min = min(cvar_width,cvar_height)
--------------------------------------------------------------------------------------
local AceDB = LibStub("AceDB-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceConfigCmd = LibStub("AceConfigCmd-3.0")
--------------------------------------------------------------------------------------

local default_options=
{
	profile = 
	{
		lock = false,
		worldPVP = true,
		autoHide = false,
		ashran = true,
		rem_pos_left = cvar_width / 2 ,
		rem_pos_top = cvar_height / 2,
		uplift_pos_left = cvar_width / 2 ,
		uplift_pos_top = cvar_height / 2,
		rem = true,
		remMCount = 6,
		remHCount = 9,
		remCountColorLr = 1,
		remCountColorLg = 0,
		remCountColorLb = 0,
		remCountColorLa = 1,
		remCountColorMr = 0,
		remCountColorMg = 1,
		remCountColorMb = 0,
		remCountColorMa = 1,
		remCountColorHr = 0,
		remCountColorHg = 0,
		remCountColorHb = 1,
		remCountColorHa = 1,
		remMinDurationColora = 1,
		remMinDurationColorg = 1,
		remMinDurationColorb = 1,
		remMinDurationColorr = 1,
		remExpiredColora = 1,
		remExpiredColorb = 0,
		remExpiredColorg = 0,
		remExpiredColorr = 1,
		remExpiredGCD = 2,
		refreshRate = 0.1,
		remCounterFont = LSM:GetDefault("font"),
		remCounterFontSize = 30, 
		iconSize = 65,
		remMinDurationFont = LSM:GetDefault("font"),
		remMinDurationFontSize = 15,
		uplift = true,
		upliftBarWidth = 150,
		upliftBarHeight = 40,
		upliftHEf = 80,
		upliftMEf = 40,
		upliftPercentageFont = LSM:GetDefault("font"),
		upliftPercentageFontSize = 15,
		upliftAmountFont = LSM:GetDefault("font"),
		upliftAmountFontSize = 15,
		upliftPredictFactor = 1,
		UpliftEColorHa = 1,
		UpliftEColorHb = 0,
		UpliftEColorHg = 0,
		UpliftEColorHr = 1,
		UpliftEColorLa = 1,
		UpliftEColorLb = 1,
		UpliftEColorLg = 0,
		UpliftEColorLr = 0,
		UpliftEColorMa = 1,
		UpliftEColorMb = 0,
		UpliftEColorMg = 1,
		UpliftEColorMr = 0,
		extendLifeEnable = false,
		extendLife = true,
		extendLifeCounterPosLeft = cvar_width/3,
		extendLifeCounterPosTop = cvar_height/3,
		extendLifeCounterFont = LSM:GetDefault("font"),
		extendLifeCounterFontSize = 30, 
		extendLifeIconSize = 65,
		extendLifeMinDurationFont = LSM:GetDefault("font"),
		extendLifeMinDurationFontSize = 15,
		elCountColorHa = 1,
		elCountColorHb = 1,
		elCountColorHg = 0,
		elCountColorHr = 0,
		elCountColorLa = 1,
		elCountColorLb = 0,
		elCountColorLg = 0,
		elCountColorLr = 1,
		elCountColorMa = 1,
		elCountColorMb = 0,
		elCountColorMg = 1,
		elCountColorMr = 0,
		elExpiredColora = 1,
		elExpiredColorb = 0,
		elExpiredColorg = 0,
		elExpiredColorr = 1,
		elExpiredGCD = 2,
		elHCount = 4,
		elMCount = 2,
		elMinDurationColora = 1,
		elMinDurationColorb = 1,
		elMinDurationColorg = 1,
		elMinDurationColorr = 1,
		upliftEL = true,
		upliftELPosLeft = cvar_width / 3 ,
		upliftELPosTop = cvar_height / 3,
		upliftELBarWidth = 150,
		upliftELBarHeight = 40,
		upliftELPercentageFont = LSM:GetDefault("font"),
		upliftELPercentageFontSize = 15,
		upliftELAmountFont = LSM:GetDefault("font"),
		upliftELAmountFontSize = 15,
		upliftELHEf = 80,
		upliftELMEf = 40,
		upliftELEColorHa = 1,
		upliftELEColorHb = 0,
		upliftELEColorHg = 0,
		upliftELEColorHr = 1,
		upliftELEColorLa = 1,
		upliftELEColorLb = 1,
		upliftELEColorLg = 0,
		upliftELEColorLr = 0,
		upliftELEColorMa = 1,
		upliftELEColorMb = 0,
		upliftELEColorMg = 1,
		upliftELEColorMr = 0,
	}
}

function RemUplift:OnInitialize()
	RemUplift.db = AceDB:New("RemUpliftDB",default_options,true)
	self:OnCoreInitialize()
	self:RegisterChatCommand("RemUplift", "ChatCommand")
	self:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD","PLAYER_SPECIALIZATION_CHANGED")
end

function RemUplift:ChatCommand(input)
	if IsAddOnLoaded("RemUplift_Options") == false then
		local loaded , reason = LoadAddOn("RemUplift_Options")
		if loaded == false then
			self:Print("RemUplift_Options: "..reason)
			return
		end
	end
	if not input or input:trim() == "" then
		AceConfigDialog:Open("RemUplift")
	else
		AceConfigCmd:HandleCommand("RemUplift", "RemUplift","")
		AceConfigCmd:HandleCommand("RemUplift", "RemUplift",input)
	end
end